--
-- Name: SetShuttleDirectionEvent
-- Description: Shuttle direction event for multiplayer compatibility
-- Version: 1.0
-- Author: Saracaen
-- Date: 24/07/2011
--

SetShuttleDirectionEvent = {};
SetShuttleDirectionEvent_mt = Class(SetShuttleDirectionEvent, Event);

InitEventClass(SetShuttleDirectionEvent, "SetShuttleDirectionEvent");

function SetShuttleDirectionEvent:emptyNew()

	local self = Event:new(SetShuttleDirectionEvent_mt);
	self.className="SetShuttleDirectionEvent";
	
	return self;
	
end;

function SetShuttleDirectionEvent:new(object, shuttleDirection)

	local self = SetShuttleDirectionEvent:emptyNew()
	self.object = object;
	self.shuttleDirection = shuttleDirection;
	
	return self;
	
end;

function SetShuttleDirectionEvent:readStream(streamId, connection)

	local id = streamReadInt32(streamId);
	self.shuttleDirection = streamReadInt8(streamId);
	self.object = networkGetObject(id);
	self:run(connection);
	
end;

function SetShuttleDirectionEvent:writeStream(streamId, connection)

	streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteInt8(streamId, self.shuttleDirection);
	
end;

function SetShuttleDirectionEvent:run(connection)

	self.object:setShuttleDirection(self.shuttleDirection, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetShuttleDirectionEvent:new(self.object, self.shuttleDirection), nil, connection, self.object);
	end;
	
end;

function SetShuttleDirectionEvent.sendEvent(vehicle, shuttleDirection, noEventSend)

	if shuttleDirection ~= vehicle.shuttleDirection then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(SetShuttleDirectionEvent:new(vehicle, shuttleDirection), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(SetShuttleDirectionEvent:new(vehicle, shuttleDirection));
			end;
		end;
	end;
	
end;