--
-- Name: SetVarioLimitEvent
-- Description: Vario limit event for multiplayer compatibility
-- Version: 1.0
-- Author: Saracaen
-- Date: 24/07/2011
--

SetVarioLimitEvent = {};
SetVarioLimitEvent_mt = Class(SetVarioLimitEvent, Event);

InitEventClass(SetVarioLimitEvent, "SetVarioLimitEvent");

function SetVarioLimitEvent:emptyNew()

	local self = Event:new(SetVarioLimitEvent_mt);
	self.className="SetVarioLimitEvent";
	
	return self;
	
end;

function SetVarioLimitEvent:new(object, percentage, speedLevel)

	local self = SetVarioLimitEvent:emptyNew()
	self.object = object;
	self.percentage = percentage;
	self.speedLevel = speedLevel;
	
	return self;
	
end;

function SetVarioLimitEvent:readStream(streamId, connection)

	local id = streamReadInt32(streamId);
	self.percentage = streamReadInt8(streamId);
	self.speedLevel = streamReadInt8(streamId);
	self.object = networkGetObject(id);
	self:run(connection);
	
end;

function SetVarioLimitEvent:writeStream(streamId, connection)

	streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteInt8(streamId, self.percentage);
	streamWriteInt8(streamId, self.speedLevel);
	
end;

function SetVarioLimitEvent:run(connection)

	self.object:setVarioLimit(self.percentage, self.speedLevel, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetVarioLimitEvent:new(self.object, self.percentage, self.speedLevel), nil, connection, self.object);
	end;
	
end;

function SetVarioLimitEvent.sendEvent(vehicle, percentage, speedLevel, noEventSend)

	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetVarioLimitEvent:new(vehicle, percentage, speedLevel), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetVarioLimitEvent:new(vehicle, percentage, speedLevel));
		end;
	end;
	
end;